Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgroups.util
Class ExposedByteArrayOutputStream

    java.lang.Object
      java.io.OutputStream
          java.io.ByteArrayOutputStream
              org.jgroups.util.ExposedByteArrayOutputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable

    public class ExposedByteArrayOutputStream

extends java.io.ByteArrayOutputStream

Extends ByteArrayOutputStream, but exposes the internal buffer. This way we don't need to call toByteArray() which copies the internal buffer

Author:
  Bela Ban

Field Summary

Fields inherited from class java.io.ByteArrayOutputStream
`buf, count`

Constructor Summary
`ExposedByteArrayOutputStream()`
`ExposedByteArrayOutputStream(int size)`

Method Summary
`Buffer` | `getBuffer()`
`int` | `getCapacity()`
`byte[]` | `getRawBuffer()`
`void` | `reset()` Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded.
`void` | `reset(int max_size)` Resets count and creates a new buf if the current buf is > max_size.
`int` | `size()` Returns the current size of the buffer.
`byte[]` | `toByteArray()` Creates a newly allocated byte array.
`java.lang.String` | `toString()` Converts the buffer's contents into a string decoding bytes using the platform's default character set.
`java.lang.String` | `toString(int hibyte)` Deprecated. This method does not properly convert bytes into characters. As of JDK 1.1, the preferred way to do this is via the `toString(String enc)` method, which takes an encoding-name argument, or the `toString()` method, which uses the platform's default character encoding.
`java.lang.String` | `toString(java.lang.String charsetName)` Converts the buffer's contents into a string by decoding the bytes using the specified `charsetName`.
`void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
`void` | `write(int b)`
`void` | `writeTo(java.io.OutputStream out)` Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

Methods inherited from class java.io.ByteArrayOutputStream
`close`

Methods inherited from class java.io.OutputStream
`flush, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ExposedByteArrayOutputStream

    public ExposedByteArrayOutputStream()

### ExposedByteArrayOutputStream

    public ExposedByteArrayOutputStream(int size)

Method Detail

### reset

    public void reset(int max_size)

  Resets count and creates a new buf if the current buf is > max_size. This method is not synchronized

### getRawBuffer

    public byte[] getRawBuffer()

### getBuffer

    public Buffer getBuffer()

### getCapacity

    public int getCapacity()

### write

    public void write(int b)

  Overrides:
    `write` in class `java.io.ByteArrayOutputStream`

### write

    public void write(byte[] b,
                      int off,
                      int len)

  Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.

  Overrides:
    `write` in class `java.io.ByteArrayOutputStream`
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.

### writeTo

    public void writeTo(java.io.OutputStream out)
                 throws java.io.IOException

  Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

  Overrides:
    `writeTo` in class `java.io.ByteArrayOutputStream`
  Parameters:
    `out` - the output stream to which to write the data.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### reset

    public void reset()

  Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded. The output stream can be used again, reusing the already allocated buffer space.

  Overrides:
    `reset` in class `java.io.ByteArrayOutputStream`
  See Also:
    `ByteArrayInputStream.count`

### toByteArray

    public byte[] toByteArray()

  Creates a newly allocated byte array. Its size is the current size of this output stream and the valid contents of the buffer have been copied into it.

  Overrides:
    `toByteArray` in class `java.io.ByteArrayOutputStream`
  Returns:
    the current contents of this output stream, as a byte array.
  See Also:
    `ByteArrayOutputStream.size()`

### size

    public int size()

  Returns the current size of the buffer.

  Overrides:
    `size` in class `java.io.ByteArrayOutputStream`
  Returns:
    the value of the `count` field, which is the number of valid bytes in this output stream.
  See Also:
    `ByteArrayOutputStream.count`

### toString

    public java.lang.String toString()

  Converts the buffer's contents into a string decoding bytes using the platform's default character set. The length of the new `String` is a function of the character set, and hence may not be equal to the size of the buffer.

  This method always replaces malformed-input and unmappable-character sequences with the default replacement string for the platform's default character set. The CharsetDecoder class should be used when more control over the decoding process is required.

  Overrides:
    `toString` in class `java.io.ByteArrayOutputStream`
  Returns:
    String decoded from the buffer's contents.
  Since:
    JDK1.1

### toString

    public java.lang.String toString(java.lang.String charsetName)
                              throws java.io.UnsupportedEncodingException

  Converts the buffer's contents into a string by decoding the bytes using the specified `charsetName`. The length of the new `String` is a function of the charset, and hence may not be equal to the length of the byte array.

  This method always replaces malformed-input and unmappable-character sequences with this charset's default replacement string. The `CharsetDecoder` class should be used when more control over the decoding process is required.

  Overrides:
    `toString` in class `java.io.ByteArrayOutputStream`
  Parameters:
    `charsetName` - the name of a supported charset``
  Returns:
    String decoded from the buffer's contents.
  Throws:
    `java.io.UnsupportedEncodingException` - If the named charset is not supported
  Since:
    JDK1.1

### toString

    @Deprecated
    public java.lang.String toString(int hibyte)

  Deprecated. This method does not properly convert bytes into characters. As of JDK 1.1, the preferred way to do this is via the `toString(String enc)` method, which takes an encoding-name argument, or the `toString()` method, which uses the platform's default character encoding.

  Creates a newly allocated string. Its size is the current size of the output stream and the valid contents of the buffer have been copied into it. Each character c in the resulting string is constructed from the corresponding element b in the byte array such that:

  >          c == (char)(((hibyte & 0xff) << 8) | (b & 0xff))

  Overrides:
    `toString` in class `java.io.ByteArrayOutputStream`
  Parameters:
    `hibyte` - the high byte of each resulting Unicode character.
  Returns:
    the current contents of the output stream, as a string.
  See Also:
    `ByteArrayOutputStream.size()`, `ByteArrayOutputStream.toString(String)`, `ByteArrayOutputStream.toString()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.